/***************************************************************************
 *   Copyright (C) 2007 by seth jackson   				   	   *
 *      								  			   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of version 2 of the GNU General Public License as  *
 *   published by the Free Software Foundation.                        	   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define MAX_FILENAME       255
#define BUFFER_SIZE          3
#define NEW_TAG      "_.txt"

void Replace(char* iFileName, FILE* iFile);
void Error();

int main(int argc, char* argv[])
{
    int i = 1;
    FILE* iFile = NULL;
    char iFileName[MAX_FILENAME];
    
    for (i = 1; i < argc; i++)
    {
        strcpy(iFileName, argv[i]); 
        iFile = fopen(iFileName, "rb");
        if (iFile == NULL)
        {
            Error("iFile open failed");
            return 1;
        }
        Replace(iFileName, iFile);
        fclose(iFile);
    }
    return 0;
}

void Replace(char* iFileName, FILE* iFile)
{
    char oFileName[MAX_FILENAME];
    int Buffer[BUFFER_SIZE];
    int done = 0;
    FILE* oFile = NULL;
    
    strcpy(oFileName, iFileName);
    strcat(oFileName, NEW_TAG);
    oFile = fopen(oFileName, "wb");
    if (oFile == NULL)
    {
        Error("oFile open failed");
        return;
    }
    
    while(done == 0)
    {
        Buffer[0] = fgetc(iFile);
        if ((0x20 <=  Buffer[0]) && (0x7E >= Buffer[0]))
        {
            fputc(Buffer[0], oFile);
        }
        else
        {
            switch(Buffer[0])
            {
                case EOF:
                {
                    done = 1;
                    fputc(EOF, oFile);
                    break;
                }
                
                case 0x0D:
                {
                    Buffer[1] = fgetc(iFile);
                    Buffer[2] = fgetc(iFile);
                   
                    if (Buffer[2] == 0x0D)
                    {
                        fputc(0x0A, oFile);
                        fputc(0x0A, oFile);
                        break;
                    }
                    if (Buffer[2] == 0x0A)
                    {
                        fputc(0x0A, oFile);
                        fputc(0x0A, oFile);
                        break;                        
                    }
                    if (Buffer[2] == 0x20)
                    {
                        fputc(0x0A, oFile);
                        fputc(0x20, oFile);
                        break;
                    }
                    
                    fputc(0x20, oFile);
                    fputc(Buffer[2], oFile);
                    break;
                }
                case 0x0A:
                {
                    Buffer[1] = fgetc(iFile);

                    if (Buffer[1] == 0x0A)
                    {
                        fputc(0x0A, oFile);
                        fputc(0x0A, oFile);
                        break;                        
                    }
                    if (Buffer[1] == 0x20)
                    {
                        fputc(0x0A, oFile);
                        fputc(0x20, oFile);
                        break;
                    }
                    
                    fputc(0x20, oFile);
                    fputc(Buffer[1], oFile);
                    break;
                }
                case 0x09:
                {
                    fputc(0x09, oFile);
                    break;
                }
                default:
                {
                    fputc(Buffer[0], oFile);
                    break;
                }
            }
        }
    }
}

void Error(const char* message)
{
    fprintf(stderr, message);
}
